Bug 1562244 - HAProxy keep-alive timeout exceeded by 5 seconds (docs)
Summary: HAProxy keep-alive timeout exceeded by 5 seconds (docs)
Keywords:
Status: CLOSED CURRENTRELEASE
Alias: None
Product: OpenShift Container Platform
Classification: Red Hat
Component: Documentation
Version: 3.9.0
Hardware: Unspecified
OS: Unspecified
medium
medium
Target Milestone: ---
: 3.10.0
Assignee: Vikram Goyal
QA Contact: Vikram Goyal
Vikram Goyal
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2018-03-29 21:14 UTC by Aleksandar Kostadinov
Modified: 2018-07-23 13:10 UTC (History)
8 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2018-07-09 00:29:30 UTC
Target Upstream Version:


Attachments (Terms of Use)
ruby keep-alive test script (1.96 KB, text/plain)
2018-03-29 21:14 UTC, Aleksandar Kostadinov
no flags Details
ruby keep-alive test script (1.97 KB, text/plain)
2018-03-29 21:19 UTC, Aleksandar Kostadinov
no flags Details


Links
System ID Priority Status Summary Last Updated
Github openshift openshift-docs pull 8900 None None None 2018-04-26 18:56:47 UTC

Description Aleksandar Kostadinov 2018-03-29 21:14:52 UTC
Created attachment 1414943 [details]
ruby keep-alive test script

Description of problem:
Setting ROUTER_SLOWLORIS_HTTP_KEEPALIVE to some number of seconds, e.g. 10s makes HAProxy close client connection after 15s. If the setting is 7s, then connection is closed after 12s of inactivity.

Version-Release number of selected component (if applicable):
3.9.14-1.git.0.4efa2ca.el7.x86_64

How reproducible:
always

Steps to Reproduce:
1. set variable in router dc ROUTER_SLOWLORIS_HTTP_KEEPALIVE=10s
2. wait router to restart
3. create some app in a user project
4. test keep-alive:
4.1. connect server
4.2. execute get command
4.3. wait

Actual results:
connection closes after 15 seconds

Expected results:
connection closes after 10 seconds

Additional info:
Please check attached ruby script to see how this is being tested.

Comment 1 Aleksandar Kostadinov 2018-03-29 21:19:00 UTC
Created attachment 1414944 [details]
ruby keep-alive test script

Comment 2 jtanenba 2018-04-17 15:40:35 UTC
Some of the timeouts are additive, in this case 

ROUTER_SLOWLORIS_HTTP_KEEPALIVE which adjusts "timeout http-keep-alive" triggers and then haproxy still waits on the "tcp-request inspect-delay" which we set to 5s 


I will update the docs mentioning that some of the timeouts interact so they may not be exactly as set

Comment 3 Aleksandar Kostadinov 2018-04-17 16:01:21 UTC
Thank you, we will adjust our tests according to docs when ready.

Comment 6 zhaozhanqi 2018-05-16 05:44:05 UTC
Checked the document PR, Verified this bug


Note You need to log in before you can comment on or make changes to this bug.